/*
 * This file is part of the UCB release of Plan 9. It is subject to the license
 * terms in the LICENSE file found in the top-level directory of this
 * distribution and at http://akaros.cs.berkeley.edu/files/Plan9License. No
 * part of the UCB release of Plan 9, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms contained
 * in the LICENSE file.
 */

#include <u.h>
#include <libc.h>

#define	N	256

char*
jehanne_strtok(char *s, char *b)
{
	static char *under_rock;
	char map[N], *os;

	jehanne_memset(map, 0, N);
	while(*b)
		map[*(uint8_t*)b++] = 1;
	if(s == 0)
		s = under_rock;
	while(map[*(uint8_t*)s++])
		;
	if(*--s == 0)
		return 0;
	os = s;
	while(map[*(uint8_t*)s] == 0)
		if(*s++ == 0) {
			under_rock = s-1;
			return os;
		}
	*s++ = 0;
	under_rock = s;
	return os;
}
