/*
 * This file is part of the UCB release of Plan 9. It is subject to the license
 * terms in the LICENSE file found in the top-level directory of this
 * distribution and at http://akaros.cs.berkeley.edu/files/Plan9License. No
 * part of the UCB release of Plan 9, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms contained
 * in the LICENSE file.
 */

#include <u.h>
#include <libc.h>


/*
 * Return pointer to first occurrence of s2 in s1,
 * 0 if none
 */
char*
jehanne_utfutf(const char *s1, const char *s2)
{
	const char *p;
	int32_t f, n1, n2;
	Rune r;

	n1 = jehanne_chartorune(&r, s2);
	f = r;
	if(f <= Runesync)		/* represents self */
		return jehanne_strstr(s1, s2);

	n2 = jehanne_strlen(s2);
	for(p=s1; p=jehanne_utfrune(p, f); p+=n1)
		if(jehanne_strncmp(p, s2, n2) == 0)
			return (char*)p;
	return 0;
}
